/* q_main - test routine for queue package */
#include "local.h"
#include "queue.h"
#define NAME_NODE struct name_node
NAME_NODE
	{
	NAME_NODE *next;
	char name[4];
	};
NAME_NODE *front = NULL;		/* front node of queue */
NAME_NODE *rear = NULL;			/* rear node of queue */
NAME_NODE *p = NULL;			/* current node */
void show_cmds(), append_name(), push_name(), pop_name(), dump_names();
main()
	{
	char buf[2];				/* buffer for input */

	show_cmds();
	Q_OPEN(&front, &rear);		/* open the queue */
	FOREVER
		{
		if (getreply("?: ", buf, 2) == EOF)
			exit(0);
		switch (buf[0])
			{
		case '>':
			append_name();
			break;
		case '+':
			push_name();
			break;
		case '-':
			pop_name();
			break;
		case '=':
			dump_names();
			break;
		case '0':
			Q_CLOSE(&front, &rear);
			Q_OPEN(&front, &rear);		/* open the queue */
			break;
		case '?':
			show_cmds();
			break;
		default:
			printf("unknown command: %c\n", buf[0]);
			show_cmds();
			break;
			}
		}
	}																	/*
.PE
.PS 44
/* show_cmds -- show legal commands */
void show_cmds()
	{
	printf("Type > to append, + to push, - to pop, = to print, 0 to reset:\n");
	}
/* append_name - append new name on queue */
void append_name()
	{
	p = (NAME_NODE *)malloc(sizeof(NAME_NODE));
	if (p == NULL)
		error("out of space", "");
	getreply("name: ", p->name, 4);
	Q_APPEND(&front, &rear, p);
	}
/* push_name - push new name on queue */
void push_name()
	{
	p = (NAME_NODE *)malloc(sizeof(NAME_NODE));
	if (p == NULL)
		error("out of space", "");
	getreply("name: ", p->name, 4);
	Q_PUSH(&front, &rear, p);
	}
/* pop_name - pop a name off queue */
void pop_name()
	{
	p = (NAME_NODE *)Q_POP(&front, &rear);
	if (p == NULL)
		printf("EMPTY QUEUE\n");
	else
		{
		printf("name= %s\n", p->name);
		free(p);
		}
	}
/* dump_names - print the current queue of names */
void dump_names()
	{
	if (front == NULL)
		printf("EMPTY QUEUE\n");
	else
		EACH_Q(front, p)
			printf("name= %s\n", p->name);
	}
